// booleanf.h Boolean funcitons
//

//const int nVar =8;			// the number of boolean variables
//const int nVar2=1<<nVar;		// 2^nVar
#define nVar 4					// the number of boolean variables
#define nVar2 (1<<nVar)			// 2^nVar

#if nVar<= 8
typedef unsigned char corteg;	// <= BYTE
#elif nVar<= 16 
typedef unsigned short corteg;	// <= __in16
#elif nVar<= 32
typedef unsigned corteg;		// <= __in32
#elif nVar<= 64
typedef unsigned __int64 corteg;// <= __in64
#else
#error nVar too large
#endif


class SC{	// Set of Corteges
			// must bee bit array, but temporary - byte array
private:
	unsigned char v[nVar2];		// bytes with 0 or 1
	
public:
	// constructors/destructor
	SC();
	SC(SC &a){ vError("SC::SC(SC &a): copy constructor illegal"); }
	~SC();
	//
	void set0();						// this = 0
	bool get(corteg a);					// if the corteg (a) in the set (this)
	void ins(corteg a);					// add corteg (a) to the set (this)
	void join  (SC &s);					// add set (s) to (this)
	void inters(SC &s);					// (this) := (this) int   (s)
	void xor   (SC &s);					// (this) := (this) XOR (s)
	int  weight();						// the number of elements 
	bool isBitSymmetric( int k );		// is set (this) simmetric with respect bit (k)
	char *toString();
};

// Boolean polynom is the sum of a boolean monomials.
// And each monomial is determined the list of variables included, e.g. some cortege.
// So (BP) as a set is the same as (SC) as a set
class BP{ // Boolean polynoms
private:
	unsigned char v[nVar2];		// bytes with 0 or 1
public:
	// constructors/destructor
	BP();
	BP(BP &a){ vError("BP::BP(BP &a): copy constructor illegal"); }
	~BP();
	//
	void set0();						// this = 0
	void set1(corteg a);				// v[a] = 1
	void add1(corteg a);				// v[a]+= 1
	void add(BP &b);					// this += b
	void mult(BP &b, BP &c);			// this = b*c
	bool get(corteg a);					// this(a)
	void values(SC &r);					// r.v[a] := this(a)   a
	void Roots(SC &r);					// r := roots(this)
	void OneUnit(corteg a);				// this = polynom with non-roots only a
	void OneRoot(corteg a);				// this = polynom with roots only a
	void or(BP &b, BP &c);				// this = b OR c
	void givenUnits(SC &r);				// this = polynom with units exactly in r
	void givenRoots(SC &r);				// this = polynom with roots exactly in r

	char *toString();
};
//

